﻿@page "/program-list"
@inject IProgramsRepository ProgramsRepository

<MudGrid>
    <PageTitle Title="プログラム一覧" />
    <MudSpacer />
    <MudFab Color="Color.Primary" Icon="@Icons.Material.Filled.Add" Size="Size.Small" Label="追加" Link="/program-detail" />
</MudGrid>

<MudGrid>
    <MudItem md="12">
        <MudTable Items="@_programs" Class="mt-4"
                  Bordered="true" Dense="true" Striped="true" FixedHeader="true" Hover="true" Loading="_loading">
            <ToolBarContent>
                <MudItem md="4">
                    <SubSystemSelection @bind-SystemId="_searchItem.SystemId" @bind-SubSystemId="_searchItem.SubSystemId" />
                </MudItem>
                <MudItem md="4" Class="ml-4">
                    <MudTextField @bind-Value="_searchItem.SearchString"
                                  AdornmentIcon="@Icons.Material.Filled.Search" Adornment="Adornment.Start" />
                </MudItem>
                <MudItem md="1" Class="ml-4">
                    <MudFab Color="Color.Primary" Icon="@Icons.Material.Filled.Search" Size="Size.Small" Label="表示" OnClick="Search" />
                </MudItem>
            </ToolBarContent>

            <HeaderContent>
                <MudTh>システム</MudTh>
                <MudTh>サブシステム</MudTh>
                <MudTh>プログラムID</MudTh>
                <MudTh>プログラム名</MudTh>
                <MudTh>目的</MudTh>
                <MudTh>機能概要</MudTh>
                <MudTh>操作</MudTh>
            </HeaderContent>
            <RowTemplate>
                <MudTd>@context.SubSystem.System.Name</MudTd>
                <MudTd>@context.SubSystem.Name</MudTd>
                <MudTd>@context.ProgramId</MudTd>
                <MudTd>@context.Name</MudTd>
                <MudTd>@context.Purpose</MudTd>
                <MudTd>@context.FunctionalOverview</MudTd>
                <MudTd>
                    <MudTooltip Text="編集">
                        <MudFab Link=@($"/program-detail") Color="Color.Primary" Icon="@Icons.Material.Filled.Edit" Size="Size.Small"></MudFab>
                    </MudTooltip>
                </MudTd>
            </RowTemplate>
        </MudTable>
    </MudItem>
</MudGrid>

@code {
    private IEnumerable<ProgramEntity> _programs = new List<ProgramEntity>();
    private ProgramListSearchItemDto _searchItem = new();
    private bool _loading = false;

    private async void Search()
    {
        _loading = true;
        _programs = await ProgramsRepository.GetPrograms(_searchItem);
        _loading = false;
    }
}